﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
//using System.IO;

//namespace CommunityDetection
//{
//    class FileConvertorss
//    {
//        public static void graphToFicInput(string input, string output)
//        {
//            Console.Write("Reading " + input + "... ");
//            UndirectedGraphList graph = new UndirectedGraphList(input);
//            Console.WriteLine("Done!");
//            Console.Write("Writing " + output + "... ");
//            StreamWriter tileWriter = new StreamWriter(output);
//            for (int i = 0; i < graph.Count; i++)
//            {
//                HashSet<int> vertices = graph.getNeighbours(i);
//                List<int> list = vertices.ToList();
//                list.Add(i);
//                list.Sort();
//                tileWriter.Write(list[0]);
//                for (int j = 1; j < list.Count; j++)
//                    tileWriter.Write(" " + list[j]);
//                if(i<graph.Count - 1)
//                    tileWriter.WriteLine();
//            }
//            Console.WriteLine("Done!");
//            tileWriter.Close();
//            Console.WriteLine("Finished");
//        }

//        public static void subsetOfGraph(string input, string output, int size)
//        {
//            Console.Write("Reading old graph "+input+"... ");
//            UndirectedGraphList graphOld = new UndirectedGraphList(input);
//            Console.WriteLine("Done!");

//            if (size >= graphOld.Count)
//            {
//                Console.WriteLine("Error: New size is larger or equal than old size");
//                return;
//            }

//            Console.Write("Creating set of vertices... ");
//            HashSet<int> vertices = new HashSet<int>();
//            for (int i = 0; i < size; i++)
//                vertices.Add(i);
//            Console.WriteLine("Done!");
			
//            Console.Write("Creating new graph with size "+size+"... ");
//            UndirectedGraphList graphNew = new UndirectedGraphList(size);
//            Console.WriteLine("Done!");

//            Console.Write("Adding adges to new graph... ");
//            for (int v = 0; v < size; v++)
//            {
//                HashSet<int> neighbours = graphOld.getNeighbours(v);
//                foreach(int u in neighbours)
//                {
//                    if (u < size)
//                        graphNew.addEgde(u, v);
//                }
//            }
//            Console.WriteLine("Done!");

//            Console.Write("Writing new grapg on" + output + "... ");
//            graphNew.write(output);
//            Console.WriteLine("Done!");
//            Console.WriteLine("Finished");
//        }

//        public static void graphToDescriptionMatrix(string input, string output)
//        {
//            Console.Write("Reading input graph... ");
//            UndirectedGraphMatrix graph = new UndirectedGraphMatrix(input);
//            Console.WriteLine("Done!");

//            Console.Write("Creating output graph... ");
//            int[][] data = graph.matrix.Data;
//            BinaryMatrix bm = new BinaryMatrix(data.Length, data[0].Length/2);
//            Console.WriteLine("Done!");

//            Console.Write("Filling output graph... ");
//            Random r = new Random();
//            for(int i=0; i<data.Length; i++)
//            {
//                for (int j = 0; j < data[0].Length; j+=2)
//                {
//                    if (data[i][j] != 0 && data[i][j+1] == 0 || r.NextDouble()<0.2)
//                        bm.set(i, j/2, true);
//                    if (r.NextDouble() < 0.84)
//                        bm.set(i, j/2, r.NextDouble() < 0.6);
//                }
//            }
//            Console.WriteLine("Done!");

//            Console.Write("Writing output graph... ");
//            bm.print(new StreamWriter(output), 2);
//            Console.WriteLine("Done!");
//            Console.WriteLine("Finished!");
//        }

//        public static void csvToGraph(string dir, string set, StreamWriter writer)
//        {
//            Console.WriteLine("reading nodes file "+dir+set);
//            StreamReader rn = new StreamReader(dir + "nodes.csv");
//            string line = null;
//            int counter = 0;
//            Dictionary<int, int> nodes = new Dictionary<int, int>();

//            int nNDouble = 0;
//            int nEDouble = 0;
//            int nENoEdge = 0;
//            int nEmpty = 0;
//            int nEOutOfRange = 0;
//            while (null != (line = rn.ReadLine()))
//            {
//                if (line.Equals(""))
//                {
//                    nEmpty++;
//                    continue;
//                }
//                int v = int.Parse(line);
//                if (!nodes.ContainsKey(v))
//                    nodes.Add(v, counter++);
//                else
//                    nNDouble++;
//            }
//            rn.Close();
//            Console.WriteLine("Found " + nodes.Count + " vertices");
//            UndirectedGraphList graph = new UndirectedGraphList(nodes.Count);
//            Console.WriteLine("Created graph with " + nodes.Count + " vertices");

//            Console.WriteLine("reading edges file");
//            StreamReader re = new StreamReader(dir + "edges.csv");
//            HashSet<int> edgeSet = new HashSet<int>();
//            while (null != (line = re.ReadLine()))
//            {
//                if (line.Equals(""))
//                {
//                    nEmpty++;
//                }
//                string[] vertices = line.Split(',');
//                if (vertices.Length < 2)
//                {
//                    nENoEdge++;
//                    continue;
//                }
//                try
//                {
//                    int v1 = int.Parse(vertices[0]);
//                    edgeSet.Add(v1);
//                    int v2 = int.Parse(vertices[1]);
//                    edgeSet.Add(v2);
//                    if (nodes.ContainsKey(v1) && nodes.ContainsKey(v2))
//                    {
//                        if (!graph.isEdge(nodes[v1], nodes[v2]))
//                            graph.addEgde(nodes[v1], nodes[v2]);
//                        else
//                            nEDouble++;
//                    }
//                    else
//                    {
//                        nEOutOfRange++;
//                    }
//                }
//                catch (Exception e)
//                {
//                    try
//                    {
//                        edgeSet.Add(int.Parse(vertices[1]));
//                    }
//                    catch { }
//                    Console.WriteLine(e);
//                }
//            }
//            //setname
//            writer.Write(set + ";");
//            writer.Write(graph.Count + ";");
//            writer.Write(graph.NumEdges + ";");
//            writer.Write(edgeSet.Count + ";");
//            writer.Write(nNDouble + ";");
//            writer.Write(nEDouble + ";");
//            writer.Write(nENoEdge + ";");
//            writer.Write(nEOutOfRange + ";");
//            writer.WriteLine(nEmpty);

//            Console.WriteLine("Added " + graph.NumEdges + " edges");
//            re.Close();
//            Console.WriteLine("writing graph file");
//            graph.write(dir + "graph.txt");
//            Console.WriteLine("Finished");
//        }
//    }
//}
