﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	/**
	 * Create a single candidate
	 */
	class SingleCandidateGenerator : CandidatesGenerator
	{
		Community candidate;

		public SingleCandidateGenerator(Community c)
		{
			this.candidate = c;
		}

		public SingleCandidateGenerator(int v)
		{
			Community c = new Community(graph);
			c.AddVertice(v);
			this.candidate = c;
		}

		protected override ThreadSafeQueue<Community> generate(ThreadSafeQueue<Community> queue)
		{
			queue.Enqueue(candidate);
			return queue;
		}

		public override string abbr()
		{
			return "sc-" + (smartStart ? "y" : "n");
		}
	}
}
