﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	public class RemineClassifier : Classifier
	{
		public PatternNode root;

		public RemineClassifier(): base()
		{
			root = new PatternNode();
		}

		public override bool classify(BitArray values, int row)
		{
			return root.classify(values);
		}

		public void Write(string file)
		{
			StreamWriter writer = new StreamWriter(file);
			writer.WriteLine("# First child (left) node of node V is not having the pattern Vpattern, second");
			writer.WriteLine("# child (right) is having Vpattern");
			writer.WriteLine("# ");
			root.print(0, writer);
			writer.Close();
		}
	}
}
