﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	class CommunityEqualityComparer : IEqualityComparer<Community>, IComparer<Community>
	{
		public int count = 0;

		public bool Equals(Community c1, Community c2)
		{
			count++;
			return c1.Equals(c2);
		}

		public int Compare(Community c1, Community c2)
		{
			return c1.CompareTo(c2);
		}


		public int GetHashCode(Community c)
		{
			int hash = 0;
			foreach(int v in c.getVertices().Keys)
			{
				hash = hash ^ (v * v);
			}
			return hash;
		}
	}
}
